% Black-Derman-Toy interest rate tree fitted to yield curve data.
% Reproduces Figure 8.4 in Clewlow and Strickland's book 
% "Implementing Derivatives Models"

clc; clear;

% Volatility
sigma = .10;

% Number of tree steps (N) and maturity.
N = 3;
T = 3;
dt = T/N;

% Tenors, rates.
Tenors = [1 2 3 4];
Rates  = [5 5 5 5]./100;

% Discount factors
P = 1./(1+Rates.*dt).^Tenors;

% Return the interest rate tree (r), the discount factors (d),
% and the Arrow-Debreu securities prices
[r d Q] = BuildBDTtree_yields(N,Rates(1),P,sigma,dt)
